package com.puship.test;

import static org.junit.Assert.fail;

import java.net.UnknownHostException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

import org.json.JSONArray;
import org.junit.Test;

import com.puship.CoreApi;
import com.puship.Credentials;
import com.puship.PushipUtil;

public class GetApps {
	@Test
	public void test() {
		
		Credentials cr = new Credentials(ConfigClass.Username, ConfigClass.Password);
		CoreApi ca = new CoreApi(ConfigClass.AppId , cr);
		
		PushipUtil.SetTimeZone("Europe");
		
		try {
			
			HashMap<String, Object> map= new HashMap<String, Object>();
			
			map.put("Limit", "10");
			map.put("Offset", "0");
			

			
			JSONArray al= ca.GetApps(map); //returns devices depending by filters
			
			if (al!=null){
				for (int i = 0; i < al.length(); i++) {
					System.out.println(al.getJSONObject(i).get("Name"));
					System.out.println(al.getJSONObject(i).get("AccessCode"));
					System.out.println(al.getJSONObject(i).get("EnableAPNS"));
					System.out.println(al.getJSONObject(i).get("EnableBPNS"));
					System.out.println(al.getJSONObject(i).get("EnableMPNS"));
					System.out.println(al.getJSONObject(i).get("EnableGCM"));
					
					String created = al.getJSONObject(i).getString("Created");
					System.out.println(PushipUtil.ParseDate(created));
					
					String updated = al.getJSONObject(i).getString("Updated");
					System.out.println(PushipUtil.ParseDate(updated));
				}
			} else{
				System.out.println("Error during request");
			}
			 
		}catch (UnknownHostException httpe) {
			httpe.printStackTrace();
			System.out.println("Error during URL request: probably no connection or wrong URL");
		}
		catch (Exception e) {
			e.printStackTrace();
			fail("Error during GetDevices");
		}
	}

}
